<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: PubSubClient.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">PubSubClient.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> PubSubClient.h - A simple client for MQTT.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">  Nick O&#39;Leary</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">  http://knolleary.net</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">  edit by marcel.seerig</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef PubSubClient_h</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define PubSubClient_h</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;Socket.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;FreeRTOSTimer.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define MQTT_VERSION_3_1      3</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define MQTT_VERSION_3_1_1    4</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// MQTT_VERSION : Pick the version</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//#define MQTT_VERSION MQTT_VERSION_3_1</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#ifndef MQTT_VERSION</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define MQTT_VERSION MQTT_VERSION_3_1_1</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">// MQTT_MAX_PACKET_SIZE : Maximum packet size</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef MQTT_MAX_PACKET_SIZE</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define MQTT_MAX_PACKET_SIZE 128</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment">// MQTT_KEEPALIVE : keepAlive interval in Seconds</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#ifndef MQTT_KEEPALIVE</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#define MQTT_KEEPALIVE 15</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment">// MQTT_SOCKET_TIMEOUT: socket timeout interval in Seconds</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#ifndef MQTT_SOCKET_TIMEOUT</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#define MQTT_SOCKET_TIMEOUT 15</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">// MQTT_MAX_TRANSFER_SIZE : limit how much data is passed to the network client</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment">//  in each write call. Needed for the Arduino Wifi Shield. Leave undefined to</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment">//  pass the entire MQTT packet in each write call.</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">//#define MQTT_MAX_TRANSFER_SIZE 80</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">// Possible values for client.state()</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="structmqtt__InitTypeDef.html">   47</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structmqtt__InitTypeDef.html">mqtt_InitTypeDef</a>{</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    std::string     ip;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    uint16_t        port;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span>*     user;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span>*     pass;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span>*     id;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span>*     willTopic;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    uint8_t         willQos;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">bool</span>            willRetain;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">char</span>*     willMessage;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;};</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    CONNECTION_TIMEOUT      = -4,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    CONNECTION_LOST         = -3,</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    CONNECT_FAILED          = -2,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    DISCONNECTED            = -1,</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    CONNECTED               =  0,</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    CONNECT_BAD_PROTOCOL    =  1,</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    CONNECT_BAD_CLIENT_ID   =  2,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    CONNECT_UNAVAILABLE     =  3,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    CONNECT_BAD_CREDENTIALS =  4,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    CONNECT_UNAUTHORIZED    =  5,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;} mqtt_state;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    CONNECT     =  1 &lt;&lt; 4, <span class="comment">// Client request to connect to Server</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    CONNACK     =  2 &lt;&lt; 4, <span class="comment">// Connect Acknowledgment</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    PUBLISH     =  3 &lt;&lt; 4, <span class="comment">// Publish message</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    PUBACK      =  4 &lt;&lt; 4, <span class="comment">// Publish Acknowledgment</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    PUBREC      =  5 &lt;&lt; 4, <span class="comment">// Publish Received (assured delivery part 1)</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    PUBREL      =  6 &lt;&lt; 4, <span class="comment">// Publish Release (assured delivery part 2)</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    PUBCOMP     =  7 &lt;&lt; 4, <span class="comment">// Publish Complete (assured delivery part 3)</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    SUBSCRIBE   =  8 &lt;&lt; 4, <span class="comment">// Client Subscribe request</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    SUBACK      =  9 &lt;&lt; 4, <span class="comment">// Subscribe Acknowledgment</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    UNSUBSCRIBE = 10 &lt;&lt; 4, <span class="comment">// Client Unsubscribe request</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    UNSUBACK    = 11 &lt;&lt; 4, <span class="comment">// Unsubscribe Acknowledgment</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    PINGREQ     = 12 &lt;&lt; 4, <span class="comment">// PING Request</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    PINGRESP    = 13 &lt;&lt; 4, <span class="comment">// PING Response</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    DISCONNECT  = 14 &lt;&lt; 4, <span class="comment">// Client is Disconnecting</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    Reserved    = 15 &lt;&lt; 4, <span class="comment">// Reserved</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;} mqtt_message_type;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    QOS0        = (0 &lt;&lt; 1),</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    QOS1        = (1 &lt;&lt; 1),</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    QOS2        = (2 &lt;&lt; 1),</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;} mqtt_qos;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="structmqtt__message.html">   98</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structmqtt__message.html">mqtt_message</a> {</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    uint8_t type;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    uint8_t qos;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordtype">bool</span> retained;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">bool</span> dup;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    std::string topic;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    std::string payload;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    uint16_t msgId;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;};</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#define MQTT_CALLBACK_SIGNATURE void (*callback) (std::string, std::string)</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">class </span><a class="code" href="classPubSubClientTask.html">PubSubClientTask</a>;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classPubSubClient.html">  112</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPubSubClient.html">PubSubClient</a> {</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>();</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>(<a class="code" href="classSocket.html">Socket</a>&amp; client);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>(std::string ip, uint16_t port);</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>(std::string ip, uint16_t port, <a class="code" href="classSocket.html">Socket</a>&amp; client);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>(std::string ip, uint16_t port, MQTT_CALLBACK_SIGNATURE,<a class="code" href="classSocket.html">Socket</a>&amp; client);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;   ~<a class="code" href="classPubSubClient.html">PubSubClient</a>();</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>&amp; <a class="code" href="classPubSubClient.html#aa809b115adf6c551dee72d12ecfd8414">setServer</a>(std::string ip, uint16_t port);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>&amp; <a class="code" href="classPubSubClient.html#a115733ca6dd337362375d3c4a45300fe">setCallback</a>(MQTT_CALLBACK_SIGNATURE);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;   <a class="code" href="classPubSubClient.html">PubSubClient</a>&amp; <a class="code" href="classPubSubClient.html#a30e35b9461d26f3d10736ac39c9de418">setClient</a>(<a class="code" href="classSocket.html">Socket</a>&amp; client);</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">connect</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>);</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">connect</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>* user, <span class="keyword">const</span> <span class="keywordtype">char</span>* pass);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">connect</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>* willTopic, uint8_t willQos, <span class="keywordtype">bool</span> willRetain, <span class="keyword">const</span> <span class="keywordtype">char</span>* willMessage);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">connect</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>* user, <span class="keyword">const</span> <span class="keywordtype">char</span>* pass, <span class="keyword">const</span> <span class="keywordtype">char</span>* willTopic, uint8_t willQos, <span class="keywordtype">bool</span> willRetain, <span class="keyword">const</span> <span class="keywordtype">char</span>* willMessage);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">connect</a>();</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classPubSubClient.html#ac0d1c6de8a88a9f9fda04126c8cf2fe0">disconnect</a>();</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a59500b307e27b6ec9007ef1f3a0c24db">publish</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* topic, <span class="keyword">const</span> <span class="keywordtype">char</span>* payload);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a59500b307e27b6ec9007ef1f3a0c24db">publish</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* topic, <span class="keyword">const</span> <span class="keywordtype">char</span>* payload, <span class="keywordtype">bool</span> retained);</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a59500b307e27b6ec9007ef1f3a0c24db">publish</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* topic, <span class="keyword">const</span> uint8_t* payload, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> plength);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a59500b307e27b6ec9007ef1f3a0c24db">publish</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* topic, <span class="keyword">const</span> uint8_t* payload, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> plength, <span class="keywordtype">bool</span> retained);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;   <span class="comment">//bool publish_P(const char* topic, const uint8_t * payload, unsigned int plength, bool retained);</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a62ae269568ef379fb21a434f7e6d4a06">subscribe</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* topic, <span class="keywordtype">bool</span> ack = <span class="keyword">false</span>);</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af828241dd14833967c27b902b43b6491">unsubscribe</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* topic, <span class="keywordtype">bool</span> ack = <span class="keyword">false</span>);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#af6178d5e981a461e53424e3158d63b0e">isSubscribeDone</a>();</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a3bd39e46772e74c818ebbfedd4fa076f">isUnsubscribeDone</a>();</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classPubSubClient.html#a7f2097ea474209f9454dbdcb671fa2e9">connected</a>();</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;   <span class="keywordtype">int</span> <a class="code" href="classPubSubClient.html#a8a7025562e55ee15fd4469b75d535b1d">state</a>();</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classPubSubClient.html#a49518d415ae1fc9a115712bb90bcbafb">keepAliveChecker</a>();</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classPubSubClient.html#ac67061f0fdd7b98007f6f7501b6a5dbd">timeoutChecker</a>();</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;   <span class="keyword">friend</span> <span class="keyword">class     </span><a class="code" href="classPubSubClientTask.html">PubSubClientTask</a>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   <a class="code" href="classPubSubClientTask.html">PubSubClientTask</a>* m_task;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   <a class="code" href="classSocket.html">Socket</a>*          _client;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   <a class="code" href="structmqtt__InitTypeDef.html">mqtt_InitTypeDef</a> _config;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   mqtt_state       _state;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;   uint8_t          buffer[MQTT_MAX_PACKET_SIZE];</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   uint16_t         nextMsgId;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;   <span class="keywordtype">bool</span>             PING_outstanding;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   <span class="keywordtype">bool</span>             SUBACK_outstanding;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;   <span class="keywordtype">bool</span>             UNSUBACK_Outstanding;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;   <a class="code" href="classFreeRTOSTimer.html">FreeRTOSTimer</a>*   keepAliveTimer;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;   <a class="code" href="classFreeRTOSTimer.html">FreeRTOSTimer</a>*   timeoutTimer;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;   MQTT_CALLBACK_SIGNATURE;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;   <span class="keywordtype">void</span> setup();</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;   <span class="keywordtype">size_t</span> readPacket();</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;   <span class="keywordtype">bool</span> write(uint8_t header, uint8_t* buf, uint16_t length);</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;   uint16_t writeString(<span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">string</span>, uint8_t* buf, uint16_t pos);</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;   <span class="keywordtype">void</span> parseData(<a class="code" href="structmqtt__message.html">mqtt_message</a>* msg, uint16_t len);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   <span class="keywordtype">void</span> dumpData(<a class="code" href="structmqtt__message.html">mqtt_message</a>* msg);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;   std::string messageType_toString(uint8_t type);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;};</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classPubSubClient_html"><div class="ttname"><a href="classPubSubClient.html">PubSubClient</a></div><div class="ttdef"><b>Definition:</b> PubSubClient.h:112</div></div>
<div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classPubSubClient_html_af482531348f9031f7713fdee5329d237"><div class="ttname"><a href="classPubSubClient.html#af482531348f9031f7713fdee5329d237">PubSubClient::connect</a></div><div class="ttdeci">bool connect()</div><div class="ttdoc">Connect to a MQTT server with the with the previous settings. Note: do not call this function without...</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:311</div></div>
<div class="ttc" id="classPubSubClient_html_ac67061f0fdd7b98007f6f7501b6a5dbd"><div class="ttname"><a href="classPubSubClient.html#ac67061f0fdd7b98007f6f7501b6a5dbd">PubSubClient::timeoutChecker</a></div><div class="ttdeci">void timeoutChecker()</div><div class="ttdoc">This is a Timer called routine, which is called, when we reach the timeout. Used is this function for...</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:233</div></div>
<div class="ttc" id="classPubSubClient_html_aa809b115adf6c551dee72d12ecfd8414"><div class="ttname"><a href="classPubSubClient.html#aa809b115adf6c551dee72d12ecfd8414">PubSubClient::setServer</a></div><div class="ttdeci">PubSubClient &amp; setServer(std::string ip, uint16_t port)</div><div class="ttdoc">Set server ip and Port of my MQTT server.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:719</div></div>
<div class="ttc" id="structmqtt__message_html"><div class="ttname"><a href="structmqtt__message.html">mqtt_message</a></div><div class="ttdef"><b>Definition:</b> PubSubClient.h:98</div></div>
<div class="ttc" id="classPubSubClient_html_a59500b307e27b6ec9007ef1f3a0c24db"><div class="ttname"><a href="classPubSubClient.html#a59500b307e27b6ec9007ef1f3a0c24db">PubSubClient::publish</a></div><div class="ttdeci">bool publish(const char *topic, const char *payload)</div><div class="ttdoc">Publish a MQTT message.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:419</div></div>
<div class="ttc" id="classPubSubClient_html_a7f2097ea474209f9454dbdcb671fa2e9"><div class="ttname"><a href="classPubSubClient.html#a7f2097ea474209f9454dbdcb671fa2e9">PubSubClient::connected</a></div><div class="ttdeci">bool connected()</div><div class="ttdoc">Check the connection to the MQTT server.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:694</div></div>
<div class="ttc" id="classPubSubClient_html_af828241dd14833967c27b902b43b6491"><div class="ttname"><a href="classPubSubClient.html#af828241dd14833967c27b902b43b6491">PubSubClient::unsubscribe</a></div><div class="ttdeci">bool unsubscribe(const char *topic, bool ack=false)</div><div class="ttdoc">Unsubscribe a MQTT topic.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:625</div></div>
<div class="ttc" id="classPubSubClient_html_a62ae269568ef379fb21a434f7e6d4a06"><div class="ttname"><a href="classPubSubClient.html#a62ae269568ef379fb21a434f7e6d4a06">PubSubClient::subscribe</a></div><div class="ttdeci">bool subscribe(const char *topic, bool ack=false)</div><div class="ttdoc">Subscribe a MQTT topic.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:584</div></div>
<div class="ttc" id="structmqtt__InitTypeDef_html"><div class="ttname"><a href="structmqtt__InitTypeDef.html">mqtt_InitTypeDef</a></div><div class="ttdef"><b>Definition:</b> PubSubClient.h:47</div></div>
<div class="ttc" id="classPubSubClient_html_a8a7025562e55ee15fd4469b75d535b1d"><div class="ttname"><a href="classPubSubClient.html#a8a7025562e55ee15fd4469b75d535b1d">PubSubClient::state</a></div><div class="ttdeci">int state()</div><div class="ttdoc">Get the current MYTT state form the instance.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:753</div></div>
<div class="ttc" id="classPubSubClient_html_a115733ca6dd337362375d3c4a45300fe"><div class="ttname"><a href="classPubSubClient.html#a115733ca6dd337362375d3c4a45300fe">PubSubClient::setCallback</a></div><div class="ttdeci">PubSubClient &amp; setCallback(MQTT_CALLBACK_SIGNATURE)</div><div class="ttdoc">Set the callback function for incoming data.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:731</div></div>
<div class="ttc" id="classPubSubClient_html_ac0d1c6de8a88a9f9fda04126c8cf2fe0"><div class="ttname"><a href="classPubSubClient.html#ac0d1c6de8a88a9f9fda04126c8cf2fe0">PubSubClient::disconnect</a></div><div class="ttdeci">void disconnect()</div><div class="ttdoc">Disconnect form MQTT server and close the socket.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:662</div></div>
<div class="ttc" id="classPubSubClient_html_a30e35b9461d26f3d10736ac39c9de418"><div class="ttname"><a href="classPubSubClient.html#a30e35b9461d26f3d10736ac39c9de418">PubSubClient::setClient</a></div><div class="ttdeci">PubSubClient &amp; setClient(Socket &amp;client)</div><div class="ttdoc">Set the socket, which we want to use for our MQTT communication.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:742</div></div>
<div class="ttc" id="classPubSubClient_html_af6178d5e981a461e53424e3158d63b0e"><div class="ttname"><a href="classPubSubClient.html#af6178d5e981a461e53424e3158d63b0e">PubSubClient::isSubscribeDone</a></div><div class="ttdeci">bool isSubscribeDone()</div><div class="ttdoc">Check the state of subscription. If there was received a subscription ACK, we return a true here.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:614</div></div>
<div class="ttc" id="classPubSubClient_html_a3bd39e46772e74c818ebbfedd4fa076f"><div class="ttname"><a href="classPubSubClient.html#a3bd39e46772e74c818ebbfedd4fa076f">PubSubClient::isUnsubscribeDone</a></div><div class="ttdeci">bool isUnsubscribeDone()</div><div class="ttdoc">Check the state of unsubscription. If there was received a unsubscription ACK, we return a true here.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:653</div></div>
<div class="ttc" id="classPubSubClientTask_html"><div class="ttname"><a href="classPubSubClientTask.html">PubSubClientTask</a></div><div class="ttdoc">A task that will handle the PubSubClient.</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:27</div></div>
<div class="ttc" id="classFreeRTOSTimer_html"><div class="ttname"><a href="classFreeRTOSTimer.html">FreeRTOSTimer</a></div><div class="ttdoc">Wrapper around the FreeRTOS timer functions.</div><div class="ttdef"><b>Definition:</b> FreeRTOSTimer.h:16</div></div>
<div class="ttc" id="classPubSubClient_html_a49518d415ae1fc9a115712bb90bcbafb"><div class="ttname"><a href="classPubSubClient.html#a49518d415ae1fc9a115712bb90bcbafb">PubSubClient::keepAliveChecker</a></div><div class="ttdeci">void keepAliveChecker()</div><div class="ttdoc">This is a Timer called routine, which checks the PING_outstanding flag. This flag is set in this func...</div><div class="ttdef"><b>Definition:</b> PubSubClient.cpp:210</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
